Page MenuHomePhabricator

Watchlist Expiry: implement ability to see how many days left when in watchlist (mobile, advanced)
Closed, ResolvedPublic5 Estimated Story PointsOct 7 2020

Description

As a Watchlist Expiry user, I want to be able to determine the days left of a temporarily watched item when viewing my watchlist, so I can determine if any relevant changes to the watch period should be made.

Background: This work is for the Advanced Mobile Contributions feature. To turn advanced mode on, go to your settings page on the mobile site and select "Advanced mode". There are 3 potential solutions, which are:

  • Solution 1: Replace the clock icon with "XX days left"
  • Solution 2: If the user clicks on the clock icon, they are redirected to the relevant item in Special:EditWatchlist
  • Solution 3: If the user clicks on the clock icon, they see "(XX days left)"

For this ticket, we will start by trying to implement solution 3. Note that this ticket is high priority, but it does not need to be finished before the first release (scheduled for the week of September 14th).

Acceptance Criteria:

  • If the user is in the mobile watchlist (advanced mode), and they click, on the clock icon, they should see "(XX days left)"
    • The text should be directly to the right of the clock icon
    • The text should be in light grey
    • The clock can remain in place

Visual Examples:

Current behavior of mobile, advanced mode:

Screen Shot 2020-09-07 at 10.32.28 PM.png (464ร—342 px, 81 KB)

Mockup of days left displayed in mobile advanced mode:
Note: this is an earlier version that doesn't include clock icon, but can give you a general idea

Advanced Watchlist.png (690ร—320 px, 77 KB)

Event Timeline

Restricted Application added a subscriber: Aklapper. ยท View Herald TranscriptAug 27 2020, 1:44 PM
ifried renamed this task from Watchlist Expiry: fix watchlist to display how many days left (mobile, advanced) [placeholder] to Watchlist Expiry: implement ability to see how many days left when in watchlist (mobile, advanced).Aug 27 2020, 4:56 PM
ifried updated the task description. (Show Details)
ARamirez_WMF set the point value for this task to 5.Aug 27 2020, 6:02 PM
ifried moved this task from Estimated to Kanban-2020-21-Q1 on the Community-Tech board.
ifried updated the task description. (Show Details)
Samwilson added a subscriber: Samwilson.

Is this task dependent on a precursor? Because (and I might be looking at the wrong watchlist view!) it looks like there's not currently any indication of temporary watched status on the advanced mobile watchlist. Does this task include adding the clock?

Also, to clarify: "If the user clicks on the clock icon, they see 'XX days left.'" โ€” does this mean they get some sort of popup with this text? (e.g. like a PopupButtonWidget with a clock icon?) Although, I guess the whole topic of mobile tooltips is something that's standardized.

Hey, @Samwilson! Are you looking at the Advanced setting, which is turned on in Settings in mobile view? Right now, when I test, I see the clock icon (see screenshot example below) for items that I am watching temporarily. Furthermore, if I hover over the clock, it shows the day left, since the advanced mobile view basically mirrors the behavior of desktop view (see screenshot example below). Of course, if the user is actually using a mobile device, the hover functionality isn't very useful. For this reason, we discussed what we can do to fix this situation in an estimation (and perhaps you missed that estimation -- and, if so, sorry for any confusion!). Basically, we talked about the fact that there are a few potential approaches, but we decided to try a certain approach first (since it seemed technically feasible and sufficiently useful from a product perspective). This was to add some new behavior: If the user clicks on the clock icon, it displays the number of days left. I believe @dmaza may have a better understanding of the technical details. Thanks!

Screen Shot 2020-09-07 at 10.32.28 PM.png (464ร—342 px, 81 KB)

ifried updated the task description. (Show Details)
ifried added a subscriber: Prtksxna.

@Prtksxna The engineers may need to discuss some details of this ticket before taking it on, but I just wanted to ping you to get your feedback on this ticket. We talked about it in a previous estimation, and the ticket needs more details/work. Let me know what you think of the general idea and what else should be added. Thanks!

Thanks @ifried, that makes sense. That's the normal watchlist in Minerva, which is different from the one that is used when a mode called Advanced Mobile Contributions is enabled. Should definitely be fixed (because that's what's seen by users of a default MW installation), but it's separate from what's used (always? I'm not sure, maybe there are some restrictions) on WMF wikis, e.g.: https://m.wikidata.org/wiki/Special:Watchlist

mobile-watchlist.png (740ร—374 px, 38 KB)

It looks like the clock icon also needs to be made smaller in Minerva.

Hey, @Samwilson! I think we are talking about the same thing? According to the documentation for Advanced mobile contributions, it is turned on in the following way: "To turn advanced mode on, go to your settings page on the mobile site and select 'Advanced mode.'" Once you do that, you will see the clock for a temporarily watched page on watchlist. I have tested to confirm this on beta and testwiki. The Advanced mode uses the Minerva skin. However, if you have normal mode enabled, you won't see the clock icon (which is screenshot you provided above). Since we already have some functionality and support in place for the watchlist and edit:watchlist in advanced mobile contributions, we have decided to work on that first.

As an FYI, this ticket is just for the advanced mode.

Change 626546 had a related patch set uploaded (by Samwilson; owner: Samwilson):
[mediawiki/core@master] Add days left data to changes-lists' clock icons

https://gerrit.wikimedia.org/r/626546

Change 626549 had a related patch set uploaded (by Samwilson; owner: Samwilson):
[mediawiki/extensions/MobileFrontend@master] Add message to watchlist on clicking the clock icon

https://gerrit.wikimedia.org/r/626549

@ifried Instead of just adding this for advanced mode in MobileFrontend, it looks like it's better to add it for any touch device using any skin. Is this okay? (I've made a patch for core, that's ready for review.)

Example:

clocks.png (292ร—427 px, 32 KB)

Change 626549 abandoned by Samwilson:
[mediawiki/extensions/MobileFrontend@master] Add message to watchlist on clicking the clock icon

Reason:
Will add to core instead: https://gerrit.wikimedia.org/r/c/mediawiki/core/ /626546

https://gerrit.wikimedia.org/r/626549

@Samwilson Yes, I think it makes sense to add this behavior for any touch device. Thanks for making it happen!

@ifried Should the clock be grey and smaller in Minerva, to match how it is in other skins? Or is it meant to be larger and black?

status quosmaller and opaque
black-clock.png (360ร—427 px, 24 KB)
grey-clock.png (349ร—513 px, 26 KB)

Change 629244 had a related patch set uploaded (by Samwilson; owner: Samwilson):
[mediawiki/skins/MinervaNeue@master] Fix style of clock icon in changes lists

https://gerrit.wikimedia.org/r/629244

@ifried Should the clock be grey and smaller in Minerva, to match how it is in other skins? Or is it meant to be larger and black?

Smaller, yes. Instead of the opacity can we change the color to #72777d?

Smaller, yes. Instead of the opacity can we change the color to #72777d?

Good idea.

Is it possible to create differently-colored icon images? The existing normal/progressive/destructive are created at OOUI build time, I think. Or should we duplicate the clock icon and change it for this?

ARamirez_WMF changed the subtype of this task from "Task" to "Deadline".

Is it possible to create differently-colored icon images? The existing normal/progressive/destructive are created at OOUI build time, I think. Or should we duplicate the clock icon and change it for this?

Do you mean if we can get it from the OOUI build? I don't know :(

I was thinking that we could do this through CSS, but I guess it won't have wide support.

Here it is duplicated with the color changed:

Change 630714 had a related patch set uploaded (by Samwilson; owner: Samwilson):
[mediawiki/core@master] Use actual grey clock icon instead of opacity for watchlist expiry

https://gerrit.wikimedia.org/r/630714

Change 626546 merged by jenkins-bot:
[mediawiki/core@master] Add days left messages to changes-lists' clock icons

https://gerrit.wikimedia.org/r/626546

Change 629244 merged by jenkins-bot:
[mediawiki/skins/MinervaNeue@master] Fix style of clock icon in changes lists

https://gerrit.wikimedia.org/r/629244

Change 632344 had a related patch set uploaded (by MusikAnimal; owner: Samwilson):
[mediawiki/core@REL1_35] Add days left messages to changes-lists' clock icons

https://gerrit.wikimedia.org/r/632344

Change 632345 had a related patch set uploaded (by MusikAnimal; owner: Samwilson):
[mediawiki/skins/MinervaNeue@REL1_35] Fix style of clock icon in changes lists

https://gerrit.wikimedia.org/r/632345

dom_walden added a subscriber: dom_walden.
  • If the user is in the mobile watchlist (advanced mode), and they click, on the clock icon, they should see "(XX days left)"
    • The text should be directly to the right of the clock icon
    • The text should be in light grey
    • The clock can remain in place

Touching the clock icons makes a (XX days left) text appear to the right of the clock (or left of the clock if in an RTL language).

If the screen is especially small/narrow, it appears below. See second screenshot.

This only works for touching. Clicking on the clock with your mouse does nothing.

Screenshot from beta:

watchlist_mobile_advanced.png (2ร—1 px, 193 KB)

With a smaller screen (text appears below):
watchlist_mobile_advanced_narrow_screen.png (667ร—269 px, 30 KB)

Test environment: https://en.wikipedia.beta.wmflabs.org MediaWiki 1.36.0-alpha (d14ce36) 2020-10-08T06:28:53.

Test device: Samsung Galaxy S8 (emulator) and Firefox Responsive Design Mode.

Change 632344 merged by jenkins-bot:
[mediawiki/core@REL1_35] Add days left messages to changes-lists' clock icons

https://gerrit.wikimedia.org/r/632344

Change 632345 merged by jenkins-bot:
[mediawiki/skins/MinervaNeue@REL1_35] Fix style of clock icon in changes lists

https://gerrit.wikimedia.org/r/632345

I have tested this on my mobile device on production, and I'm able to see the number of days left when I tap on the clock. I needed to zoom into the clock a bit to be able to tap on it, since I sometimes accidentally tapped other items, but it worked when I properly zoomed + tapped on the clock icon. I'm marking this work as Done.